#include <stdio.h>
/* conv_bin.c : file sorgente di un programma che, dato un numero
                intero, effettua la conversione dalla sua
		rappresentazione decimale a quella binaria e viceversa */
/* Definizione dei prototipi delle funzioni */
unsigned int bin2dec(unsigned char numbin[]);
void dec2bin(unsigned int numdec, unsigned char numbin[]);
void stampabin(unsigned char numbin[]);
int main()
{
  /* Definizione delle variabili:
     numdec = numero in formato decimale
     numbin = vettore di numeri in formato binario */
  unsigned int numdec;
  unsigned char numbin[32];
  /* Fase di input del numero in formato decimale */
  printf("Dammi un numero positivo: ");
  scanf("%u",&numdec);
  /* Conversione da rappresentazione decimale a binaria */
  dec2bin(numdec,numbin);
  /* Stampa della rappresentazione binaria */
  stampabin(numbin);
  /* Conversione da rappresentazione binaria a decimale */
  numdec = bin2dec(numbin);
  /* Ristampa della rappresentazione decimale */
  printf("In rappresentazione decimale: %u\n",numdec);
  exit(0);
}
/* ### */
unsigned int bin2dec(numbin)
    unsigned char numbin[];
{
  /* Definizione della variabile contenente il risultato */
  unsigned int ris;
  /* Definizione di un contatore i */
  int i;
  /* Definizione di una variabile che contiene le potenze di 2 */
  unsigned int pot2;
  /* Azzeramento del risultato */
  ris = 0;
  /* Inizializzazione a 1 delle potenze di 2 */
  pot2 = 1;
  /* Ciclo su i che indica tutte le cifre della rappresentazione binaria */
  for(i=0;i<32;i++) {
    /* Incremento il risultato aggiungendo
       il prodotto tra la i-esima cifra binaria e la i-esima potenza di 2 */
    ris += numbin[i] * pot2;
    /* Passo alla potenza di 2 successiva */
    pot2 *= 2;
  }
  /* restituisco il valore del risultato alla funzione chiamante */
  return(ris);
}
/* ### */
void dec2bin(numdec,numbin)
    unsigned int numdec;
    unsigned char numbin[];
{
  /* Definizione di un contatore i */
  int i;
  /* Ciclo su i che indica tutte le cifre della rappresentazione binaria */
  for(i=0;i<32;i++) {
    /* Pongo la i-esima cifra binaria uguale al resto di numdec / 2 */
    numbin[i] = numdec % 2;
    /* Ridefinisco numdec uguale al quoziente di numdec / 2 */
    numdec /= 2;
  }
  return;
}
/* ### */
void stampabin(numbin)
    unsigned char numbin[];
{
  /* Definizione di un contatore i */
  int i;
  /* Ciclo all'indietro per determinare la prima cifra diversa da 0 */
  i=31;
  while(numbin[i] == 0 && i >= 1) {
    i--;
  }
  /* Stampo una frase che indica l'inizio della rappresentazione binaria */
  printf("In rappresentazione binaria: ");
  /* Ciclo all'indietro per stampare le cifre della rappresenazione binaria */
  for(;i>=0;i--) {
    /* Stampo la i-esima cifra binaria */
    printf("%1d",numbin[i]);
  }
  /* Stampa il ritorno a capo */
  printf("\n");  
  return;
}
