#include <stdio.h>
/* mol_bitw.c : file sorgente di un programma che effettua la
                moltiplicazione tra due numeri interi senza utilizzare
                l'operatore *, ma facendo ricorso in modo opportuno
                agli operatori bitwise (= bit a bit) */
/* Definizione dei prototipi delle funzioni */
unsigned int addbitw(unsigned int add1,unsigned int add2);
unsigned int molbitw(unsigned int fat1,unsigned int fat2);
int main()
{
  /* Definizione delle variabili:
     num1,num2,num3 = tre numeri */
  unsigned int num1,num2,num3;
  /* Fase di input dei due addendi*/
  printf("Dammi due numeri non negativi: ");
  scanf("%u %u",&num1,&num2);
  /* Prodotto dei due numeri utilizzando solo operatori bitwise */
  num3 = molbitw(num1,num2);
  /* Stampa del risultato */
  printf("Risultato del prodotto (effettuato con operatori bitwise): %u\n",
	 num3);
  exit(0);
}
/* ### */
unsigned int addbitw(add1,add2)
    unsigned int add1;
    unsigned int add2;
{
  /* Definizione della variabile che verra' restituita come risultato */
  unsigned int ris;
  /* Definizione di un contatore i */
  int i;
  /* Definizione di un numero nel quale mettero' i riporti */
  unsigned int rip;
  /* Inizio del ciclo di istruzioni da eseguire almeno una volta
     e da ripetersi finche' non si azzerano tutti i riporti */
  do {
    /* Poniamo ogni cifra del risultato uguale a 1 se le corrispondenti 
       cifre dei due addendi sono diverse, altrimenti la poniamo uguale a 0 */
    ris = add1 ^ add2;
    /* Se entrambe le cifre dei due addendi che corrispondono a una fissata
       posizione sono uguali ad 1 allora poniamo uguale ad 1 il riporto
       di posto successivo, altrimenti la poniamo uguale a 0 */
    rip = add1 & add2;
    rip <<= 1;
    /* Poniamo il primo addendo uguale al risultato */
    add1 = ris;
    /* Poniamo il secondo addendo uguale al riporto */
    add2 = rip;
    /* usciamo dal ciclo solo se il riporto e' uguale a 0 (=FALSE) */
  }  while(rip);
  return(ris);
}
/* ### */
unsigned int molbitw(fat1,fat2)
    unsigned int fat1;
    unsigned int fat2;
{
  /* Definizione della variabile che verra' restituita come risultato */
  unsigned int ris;
  /* Definizione di un contatore i */
  int i,j;
  /* Definizione di due numeri nei quali metteremo gli addendi che 
     sono via via introdotti dall'algoritmo di moltiplicazione */
  unsigned int add1,add2;
  /* Definizione di un numero che fungera' da maschera per comprendere
     quando una cifra della rappresentazione binaria di un numero
     e' diversa da zero */
  unsigned int maschera;
  /* Azzeramento del risultato */
  ris = 0;
  /* Inizializziamo la maschera in modo che si possa testare se la
     prima cifra della rappresentazione binaria di un numero sia
     o meno diversa da zero */
  maschera = 1;
  /* Ciclo su j che considera tutte le cifre della rappresentazione
     binaria del secondo fattore */
  for(j=0;j<32;j++)   {
    /* Se la j-esima cifra del secondo fattore e' uguale a 0 non facciamo
       nulla, altrimenti eseguiamo il seguente ciclo di istruzioni */
    if( (fat2 & maschera) != 0) {
      /* Poniamo il primo addendo uguale al risultato */
      add1 = ris;
      /* Il secondo addendo e' uguale al primo fattore traslato di
         j posizioni verso sinistra (le ultime j cifre a destra del
         secondo addendo vanno poste uguali a 0) */
      add2 = fat1 << j;
      /* Riaggiorniamo il risultato ponendolo uguale alla somma del
         primo e del secondo addendo */
      ris = addbitw(add1,add2);
    }
    /* Ridefiniamo la maschera in modo che si possa testare se la
       j-esima cifra della rappresentazione binaria di un numero sia
       o meno diversa da zero */
    maschera <<= 1;
  }
  return(ris);
}
