#include <stdio.h>
/* nomi_stringhe.c : file sorgente di un programma che effettua alcune
                     manipolazioni su una stringa formata da un nome e
                     da un cognome. Le operazioni sulle stringhe di
                     caratteri sono effettuate facendo ricorso il piu'
                     possibile a funzioni predefinite in libreria,
                     allo scopo di aumentare la propria familiarita'
		     con queste funzioni di libreria */
/* ### */
/* La prossima definizione consente di cambiare facilmente la
   lunghezza massima dei nomi e dei cognomi */
#define LUNGMAX 25
/* Definizione dei prototipi delle funzioni */
void elimina_trattino(char scritta[]);
void maiusc(char scritta[]);
void minusc(char scritta[]);
void riempi_di_spazi(char scritta[]);
void trattino_maiusc(char scritta[]);
/* ### */
int main()
{
  int lung;
  char scrittainiz[2*LUNGMAX], scrittafin[2*LUNGMAX];
  char nome[LUNGMAX], cognome[LUNGMAX];
  char *puntatore;
  printf("  Scrivimi il nome e il cognome (per favore, solo uno spazio\n");
  printf("  in tutta la scritta e usalo per separare il nome dal cognome;\n");
  printf("  se hai un nome o un cognome composto, usa il carattere _ al\n");
  printf("  posto dello spazio per separarne le parti, ad es. scrivi\n");
  printf("  'anna_maria' anziche' 'anna maria')\n");
  /* Input della scritta iniziale (composta da un nome e da un cognome)
     utilizzando l'istruzione fgets (piu' sicura) o gets */
  fgets(scrittainiz,2*LUNGMAX,stdin);
  /* Assegnamo alla variabile lung la lunghezza della stringa
     scrittainiz (conviene utilizzare la funzione strlen) */
  lung = strlen(scrittainiz);
  /* L'ultimo carattere di scrittainiz e' un LF (=va alla riga
     successiva), e' meglio eliminarlo ponendo uno 0 (cioe' il
     carattere NUL) al suo posto;
     si ricordi che il carattere LF e' in scrittainiz[lung-1] */
  scrittainiz[lung-1] = 0;
  /* Troviamo l'indirizzo di memoria corrispondente al carattere ' '
     che separa il nome dal cognome:
     assegnamo alla variabile puntatore l'indirizzo di memoria
     corrispondente (conviene utilizzare la funzione strchr) */
  puntatore = strchr(scrittainiz, ' ');
  /* Poniamo uguale a 0 (cioe' il carattere NUL) il valore del
     carattere che si trova nell'indirizzo di memoria a cui si
     riferisce puntatore */
  *puntatore = 0;
  /* Copiamo nella stringa nome la parte di stringa contenuta in
     scrittainiz fino al primo carattere NUL (conviene utilizzare la
     funzione strcpy) */
  strcpy(nome, scrittainiz);
  /* Riempiamo la stringa nome con degli spazi */
  riempi_di_spazi(nome);
  /* Facciamo diventare minuscole tutte le lettere del nome */
  minusc(nome);
  /* Mettiamo le maiuscole alla prima lettera del nome e ad ogni lettera
     che segue un trattino del tipo '_' */
  trattino_maiusc(nome);
  /* Incrementiamo di 1 l'indirizzo di memoria associato a puntatore */
  puntatore++;
  /* Copiamo nella stringa cognome la parte di stringa contenuta in
     scrittainiz a partire dall'indirizzo di memoria in puntatore fino
     al secondo carattere NUL (conviene utilizzare la funzione
     strcpy) */
  strcpy(cognome, puntatore);
  /* Riempiamo la stringa cognome con degli spazi */
  riempi_di_spazi(cognome);
  /* Facciamo diventare maiuscole tutte le lettere del cognome */
  maiusc(cognome);
  /* Copiamo il cognome nella stringa scrittafin (conviene utilizzare
     la funzione strcpy) */
  strcpy(scrittafin, cognome);
  /* Copiamo il nome in coda alla stringa scrittafin (conviene
     utilizzare la funzione strcat) */
  strcat(scrittafin, nome);
  /* Sostituisco tutti i trattini che compaiono nella stringa scrittafin
     con degli spazi */
  elimina_trattino(scrittafin);
  /* Messaggi finali di output */
  printf("\n  Riscrivo cognome e nome in un formato che spero ti piaccia:\n");
  printf("%s\n", scrittafin);
  exit(0);
}
/* ### */
void elimina_trattino(scritta)
     char scritta[];
     /* Nota: questa function mette il carattere ' ' al posto di ogni
	      carattere '_' nella stringa scritta.
	      Esempio: 'Giovanni_Battista' deve diventare
	      'Giovanni Battista' al termine della function. */
{
  char *puntatore;
  /* Cerchiamo la prima occorrenza del carattere '_' nella
     stringa scritta a partire dalla posizione iniziale:
     assegnamo alla variabile puntatore l'indirizzo di memoria
     corrispondente (conviene utilizzare la funzione strchr) */
  puntatore = strchr(scritta, '_');
  /* Mentre e' verificata la condizione che il valore di puntatore sia
     diverso da NULL, continuiamo ad eseguire il ciclo di istruzioni
     che sono comprese tra le seguenti parentesi {} */
  while(puntatore != NULL) {
    /* Poniamo uguale allo spazio il carattere che si trova
       nell'indirizzo di memoria a cui si riferisce puntatore */
    *puntatore = ' ';
    /* Incrementiamo di 1 l'indirizzo di memoria associato a puntatore */
    puntatore++;
    /* Cerchiamo la prossima occorrenza del carattere '_' nella
       stringa scritta a partire dall'indirizzo di memoria
       corrispondente a puntatore:
       assegnamo ancora alla variabile puntatore l'indirizzo di memoria
       corrispondente (conviene utilizzare la funzione strchr) */
    puntatore = strchr(puntatore, '_');
  }
  /* Uscita dalla funzione */
  return;
}
/* ### */
void maiusc(scritta)
     char scritta[];
{
  int i;
  /* Eseguiamo un ciclo su i che va da 0 alla lunghezza di scritta
     (conviene utilizzare la funzione strlen) */
  for(i=0; i<strlen(scritta); i++) {
    /* Se scritta[i] e' una lettera minuscola, mettiamo la maiuscola al
       suo posto, utilizzando la funzione toupper */
    scritta[i] = toupper(scritta[i]);
  }
}
/* ### */
void minusc(scritta)
     char scritta[];
{
  int i;
  /* Eseguiamo un ciclo su i che va da 0 alla lunghezza di scritta
     (conviene utilizzare la funzione strlen) */
  for(i=0; i<strlen(scritta); i++) {
    /* Se scritta[i] e' una lettera maiuscola, mettiamo la minuscola al
       suo posto, utilizzando la funzione tolower */
    scritta[i] = tolower(scritta[i]);
  }
}
/* ### */
void riempi_di_spazi(scritta)
     char scritta[];
{
  int i;
  /* Ciclo su i che va dalla lunghezza di scritta (conviene utilizzare
     la funzione strlen) a LUNGMAX-2 */
  for(i=strlen(scritta); i<LUNGMAX-1; i++) {
    /* Poniamo l'i-esimo carattere di scritta uguale a Space (=' ') */
    scritta[i] = ' ';
  }
  /* Poniamo l'ultimo carattere di scritta (cioe' quello di posto
     LUNGMAX-1) uguale a NUL */
  scritta[LUNGMAX-1] = 0;
}
/* ### */
void trattino_maiusc(scritta)
     char scritta[];
     /* Nota: questa function mette il carattere maiuscolo al posto del
	      minuscolo all'inizio della scritta e dopo ogni carattere '_'.
	      Esempio: 'giovanni_battista' deve diventare
	      'Giovanni_Battista' al termine della function. */
{
  char *puntatore;
  /* Facciamo diventare maiuscolo il primo carattere di scritta,
     utilizzando la funzione toupper */
  scritta[0] = toupper(scritta[0]);
  /* Cerchiamo la prima occorrenza del carattere '_' nella
     stringa scritta a partire dalla posizione iniziale:
     assegnamo alla variabile puntatore l'indirizzo di memoria
     corrispondente (conviene utilizzare la funzione strchr) */
  puntatore = strchr(scritta, '_');
  /* Mentre e' verificata la condizione che il valore di puntatore sia
     diverso da NULL, continuiamo ad eseguire il ciclo di istruzioni
     che sono comprese tra le seguenti parentesi {} */
  while(puntatore != NULL) {
    /* Incrementiamo di 1 l'indirizzo di memoria associato a puntatore */
    puntatore++;
    /* Facciamo diventare maiuscolo il carattere che si trova
       nell'indirizzo di memoria a cui si riferisce puntatore
       (conviene utilizzare la funzione toupper) */
    *puntatore = toupper(*puntatore);
    /* Cerchiamo la prossima occorrenza del carattere '_' nella
       stringa scritta a partire dall'indirizzo di memoria
       corrispondente a puntatore: assegnamo ancora alla variabile
       puntatore l'indirizzo di memoria corrispondente (conviene
       utilizzare la funzione strchr) */
    puntatore = strchr(puntatore, '_');
  }
  /* Uscita dalla funzione */
  return;
}
