#include <stdio.h>
/* nomi_int.c : file sorgente di un programma che effettua alcune
                manipolazioni su una stringa formata da un nome e da
                un cognome. Le operazioni sulle stringhe di caratteri
                sono effettuate facendo ricorso il meno possibile a
                funzioni predefinite in libreria, allo scopo di
                chiarire come i caratteri possono essere gestiti
                usando opeerazioni sugli interi */
/* ### */
/* La prossima definizione consente di cambiare facilmente la
   lunghezza massima dei nomi e dei cognomi */
#define LUNGMAX 25
/* Definizione dei prototipi delle funzioni */
int cerca_carattere(char scritta[], char c);
void copia_da_a(char scritta1[], int ncar_iniz, int ncar_fin, char scritta2[]);
void elimina_trattino(char scritta[]);
void maiusc(char scritta[]);
void minusc(char scritta[]);
void riempi_di_spazi(char scritta[], int ncar_fin);
void trattino_maiusc(char scritta[]);
int trova_separatore(char scritta[], int ncar_iniz);
/* ### */
int main()
{
  int i;
  int ncar_iniz, ncar_fin;
  char scrittainiz[2*LUNGMAX], scrittafin[2*LUNGMAX];
  char nome[LUNGMAX], cognome[LUNGMAX];
  printf("  Scrivimi il nome e il cognome (per favore, solo uno spazio\n");
  printf("  in tutta la scritta e usalo per separare il nome dal cognome;\n");
  printf("  se hai un nome o un cognome composto, usa il carattere _ al\n");
  printf("  posto dello spazio per separarne le parti, ad es. scrivi\n");
  printf("  'anna_maria' anziche' 'anna maria')\n");
  /* Inizializziamo a -1 il contatore i */

  /* Input della scritta iniziale (composta da un nome e da un cognome)
     con un ciclo do ... while ... */

  {
    /* Incrementiamo di uno il contatore i */

    /* Prendiamo da tastiera un singolo carattere alla volta
       e lo assegnamo alla stringa scrittainiz */

    /* Se il carattere, che abbiamo appena letto, di scrittainiz non e'
       LF (=line feed) rimaniamo all'interno del ciclo */
  }

  /* Poniamo l'ultimo carattere letto di scrittainiz uguale a NUL */

  /* Troviamo l'indice del primo spazio che separa il nome dal
     cognome: utilizziamo la funzione trova_separatore e assegnamo
     alla variabile ncar_fin l'indice trovato come risultato */

  /* Copiamo i caratteri di scrittainiz dalla posizione 0-esima fino
     allo spazio (escluso) nella stringa nome */

  /* Riempiamo la stringa nome con degli spazi */

  /* Facciamo diventare minuscole tutte le lettere del nome */

  /* Mettiamo le maiuscole alla prima lettera del nome e ad ogni lettera
     che segue un trattino del tipo '_' */

  /* Poniamo la variabile ncar_iniz uguale a ncar_fin+1 */

  /* Troviamo l'indice del carattere NUL che termina il cognome
     all'interno della stringa scrittainiz: utilizziamo la funzione
     trova_separatore e assegnamo alla variabile ncar_fin l'indice
     trovato come risultato */

  /* Copiamo i caratteri di scrittainiz dalla posizione
     ncar_iniz-esima fino al carattere NUL (escluso) nella stringa
     cognome */

  /* Riempiamo la stringa cognome con degli spazi */

  /* Facciamo diventare maiuscole tutte le lettere del cognome */

  /* Copiamo il cognome (ESCLUSO l'ultimo carattere NUL!) nella
     scrittafin */

  /* Copiamo il nome (INCLUSO l'ultimo carattere NUL!) nella
     scrittafin in coda al cognome (ATTENZIONE: bisogna passare
     l'indirizzo dell'elemento di scrittafin da cui vogliamo
     cominciare la copia */

  /* Sostituisco tutti i trattini che compaiono nella stringa scrittafin
     con degli spazi */

  /* Messaggi finali di output */
  printf("\n  Riscrivo cognome e nome in un formato che spero ti piaccia:\n");
  printf("%s\n", scrittafin);
  exit(0);
}
/* ### */
int cerca_carattere(scritta, c)
     char scritta[];
     char c;
     /* Nota: questa function cerca la prima occorrenza del carattere
	      c nella stringa scritta (o piu' precisamente a partire
	      dall'indirizzo di memoria passato come primo argomento).
	      Se lo trova, restituisce l'indice (non negativo)
	      dell'elemento del vettore scritta al quale l'ha trovato;
	      se non lo trova restituisce il valore -1. */
{
  int i;
  /* Inizializziamo i=0 */

  /* Eseguiamo un ciclo finche' scritta[i] e' diverso dal carattere NUL
     che termina la scritta */

  {
    /* Se scritta[i] e' uguale a c, usciamo dalla funzione restituendo
       il valore di i */


    /* Incrementiamo il contatore i */

  }
  /* Se siamo arrivati a questo punto della function significa che
     il carattere c non e' stato trovato:
     usciamo restituendo il valore -1 */

}
/* ### */
void copia_da_a(scritta1, ncar_iniz, ncar_fin, scritta2)
     char scritta1[];
     int ncar_iniz;
     int ncar_fin;
     char scritta2[];
{
  int i;
  /* Ciclo su i che va da ncar_iniz a ncar_fin */

  {
    /* Copiamo un carattere alla volta da scritta1 a scritta2, in modo
       tale che nella stringa scritta2 al posto 0-esimo venga messo il
       primo carattere di scritta1 a partire dalla posizione
       ncar_iniz, al posto 1-esimo vada il secondo carattere a partire
       dalla posizione ncar_iniz, etc. */

  }
}
/* ### */
void elimina_trattino(scritta)
     char scritta[];
     /* Nota: questa function mette il carattere ' ' al posto di ogni
	      carattere '_' nella stringa scritta.
	      Esempio: 'Giovanni_Battista' deve diventare
	      'Giovanni Battista' al termine della function. */
{
  int i, delta_i;
  /* Inizializziamo i al valore 0 */

  /* Cerchiamo la prima occorrenza del carattere '_' nella
     stringa scritta a partire dalla posizione i-esima: assegnamo a
     delta_i (perche' e' uno scostamento di un indice) il valore
     restituito dalla funzione cerca_carattere */

  /* Eseguiamo un ciclo da cui usciamo quando il valore di delta_i
     e' negativo */

  {
    /* Incrementiamo di delta_i l'indice i */

    /* Poniamo scritta[i] uguale allo spazio */

    /* Incrementiamo di 1 l'indice i */

    /* Cerchiamo la prossima occorrenza del carattere '_' nella
       stringa scritta a partire dalla posizione i-esima: assegnamo a
       delta_i (perche' e' uno scostamento di un indice) il valore
       restituito dalla funzione cerca_carattere */

  }
  /* Uscita dalla funzione */
  return;
}
/* ### */
void maiusc(scritta)
     char scritta[];
{
  int i;
  /* Inizializziamo i=0 */

  /* Eseguiamo un ciclo finche' scritta[i] e' diverso dal carattere NUL
     che termina la scritta */

  {
    /* Se scritta[i] e' una lettera minuscola, mettiamo la maiuscola al
       suo posto */


    /* Incrementiamo il contatore i */

  }
}
/* ### */
void minusc(scritta)
     char scritta[];
{
  int i;
  /* Inizializziamo i=0 */

  /* Eseguiamo un ciclo finche' scritta[i] e' diverso dal carattere NUL
     che termina la scritta */

  {
    /* Se scritta[i] e' una lettera maiuscola, mettiamo la minuscola al
       suo posto */


    /* Incrementiamo il contatore i */

  }
}
/* ### */
void riempi_di_spazi(scritta, ncar_fin)
     char scritta[];
     int ncar_fin;
{
  int i;
  /* Ciclo su i che va da ncar_fin a LUNGMAX-2 */

  {
    /* Poniamo l'i-esimo carattere di scritta uguale a Space (=' ') */

  }
  /* Poniamo l'ultimo carattere di scritta (cioe' quello di posto
     LUNGMAX-1) uguale a NUL */

}
/* ### */
void trattino_maiusc(scritta)
     char scritta[];
     /* Nota: questa function mette il carattere maiuscolo al posto del
	      minuscolo all'inizio della scritta e dopo ogni carattere '_'.
	      Esempio: 'giovanni_battista' deve diventare
	      'Giovanni_Battista' al termine della function. */
{
  int i, delta_i;
  /* Inizializziamo i al valore -1 */

  /* Eseguiamo un ciclo con test di uscita alla fine del ciclo stesso */

  {
    /* Incrementiamo di 1 l'indice i */

    /* Se scritta[i] e' una lettera minuscola, mettiamo la maiuscola al
       suo posto */


    /* Cerchiamo la prossima occorrenza del carattere '_' nella
       stringa scritta a partire dalla posizione i-esima: assegnamo a
       delta_i (perche' e' uno scostamento di un indice) il valore
       restituito dalla funzione cerca_carattere */

    /* Incrementiamo di delta_i l'indice i */

    /* Se il valore di delta_i e' >= 0, ripetiamo un'altra volta il
       ciclo di istruzioni contenute dalla coppia di parentesi {}
       nella quale ci troviamo */
  }

  /* Uscita dalla funzione */
  return;
}
/* ### */
int trova_separatore(scritta, ncar_iniz)
     char scritta[];
     int ncar_iniz;
{
  int i;
  /* Inizializziamo a ncar_iniz-1 il contatore i */

  /* Consideriamo un carattere per volta della stringa scritta
     con un ciclo do ... while ... */

  {
    /* Incrementiamo di uno il contatore i */

    /* Se, nella tabella ASCII, l'i-esimo carattere di scritta e' uno
       di quelli che seguono il carattere Space (=' ') rimaniamo
       all'interno del ciclo */
  }

  /* Usciamo dalla funzione restituendo il valore del contatore i */
  return(i);
}
