#include <stdio.h>
/* tartaglia.c : file sorgente di un programma che genera la stampa
                 del triangolo di Tartaglia.  Al massimo vengono
                 stampate le righe fino alla 15-esima: il limite a 15
                 e' stato scelto in modo tale che i numeri che vi
                 compaiono sono al massimo a quattro cifre (poiche'
                 15!/(7!*8!) = 6435 ) */
/* Definizione dei prototipi delle funzioni */
void aggiornariga(int n, int vetriga[]);
void stampariga(int n, int nfin, int vetriga[]);
int main()
{
  /* Definizione delle variabili:
     n = contatore del numero di riga
     nfin = numero di  indice finale della riga
            del triangolo di Tartaglia
     vetriga = vettore contenente i numeri che appaiono
               su una riga del triangolo di Tartaglia */
  int n, nfin, vetriga[16];
  /* Fase di input del numero finale di riga */
  do {
    printf("Dammi un numero non negativo (deve essere <=15): ");
    scanf("%d",&nfin);
  } while( nfin < 0 || nfin > 15 );
  /* Inizializzazione della riga 0-esima */
  vetriga[0] = 1;
  /* Ciclo su n che indica le righe del triangolo di Tartaglia */
  for(n=0;n<=nfin;n++) {
    /* Stampa della riga n-esima del triangolo di Tartaglia */
    stampariga(n,nfin,vetriga);
    /* Calcolo della riga n+1-esima a partire dalla n-esima */
    aggiornariga(n,vetriga);
  }
  exit(0);
}
/* ### */
void aggiornariga(n,vetriga)
     int n;
     int vetriga[];
{
  /* Definizione di un contatore i */
  int i;
  /* Definizione dei valori degli elementi estremi della riga */
  vetriga[0] = vetriga[n+1] = 1;
  /* Ciclo all'indietro su i che indica uno degli elementi intermedi 
     della riga */
  for(i=n;i>0;i--) {
    /* Calcolo dell'elemento i-esimo della riga n+1-esima a partire
       dagli elementi della riga n-esima */
    vetriga[i] += vetriga[i-1];
  }
  return;
}
/* ### */
void stampariga(n,nfin,vetriga)
     int n;
     int nfin;
     int vetriga[];
{
  /* Definizione di un contatore i */
  int i;
  /* Stampa degli spazi ad inizio della riga, in modo tale che:
      (a) l'unico elemento della riga 0-esima sia sull'asse di simm.
          del triangolo;
      (b) il primo elemento della nfin-esima riga sia il piu'
          a sinistra possibile;
      (c) il primo elemento della generica riga n-esima deve
          circa essere sul segmento che congiunge il primo della
	  0-esima con il primo della n-esima
  */
  for(i=0;i<((nfin-n)*5)/2;i++)
    printf(" ");
  /* Ciclo su i che indica uno degli elementi della riga n-esima */
  for(i=0;i<=n;i++) {
    /* Se l'i-esimo elemento di riga ha al massimo 2 cifre, lo stampo
       con uno spazio a sinistra e due a destra */
    if(vetriga[i] < 100)
      printf(" %2d  ",vetriga[i]);
    /* Altrimenti stampo l'i-esimo elemento di riga con uno spazio a destra */
    else
      printf("%4d ",vetriga[i]);
  }
  /* Stampa del ritorno a capo */
  printf("\n");  
  return;
}
